:: Evaluation batch for SYS4 Redcode Evolver
:: Last update Feb 28 98
:: usage: evalwar [rounds [dirmask [testmask]]]
:: if evalflag deleted, stops at the end of current benchmark
:: if warlist$/envsave$.bat present, resumes at next warrior
:: calls scorelog.bat when finally done
@echo off
if .%1==.Sub goto %2
:: defaults...
set rnds=20
set test=test\*.red
set warriors=*.red
if not .%1==. set rnds=%1
if not .%2==. set warriors=%2
if not .%3==. set test=%3
set pmars=pmars -b
if not exist %test% goto testerror
echo Evalwar is running>evalflag
if exist warlist$ goto continue
if exist battle.out del battle.out
dir /s /b /-p %warriors%>warlist$
echo.>>warlist$
echo>envsave$.bat set rnds=%rnds%
:continue
call envsave$.bat
set pmars=%pmars% -r %rnds%
echo %0 Sub process %%4>enter.bat
:mainloop
if not exist evalflag goto stop
type warlist$|date|find "Enter">wartemp$.bat
wartemp$
:done
call scorelog battle.out scores.txt
del warlist$
del envsave$.bat
:stop
del enter.bat
del wartemp$.bat
del score$$$
del test$.war
if exist evalflag del evalflag
goto end
:process
if .%3==. goto done
copy %3 test$.war>nul
for %%i in (%test%) do call %0 Sub battle test$.war %%i
type warlist$|find /v "%3">warlist$
goto mainloop
:battle
>score$$$ %pmars% %3 %4
type score$$$
type score$$$>>battle.out
:end
