:: Front-end batch for SYS4 Redcode Evolver
:: For Windows 95 with Perl for Win32, uses QBasic
:: Req batches: sys4evol colorize evalwar test1war scorelog
:: progs: perl qbasic edit find debug mode deltree more choice
:: scripts: makerand.pl map?????.pl config.pl makeword.bas
:: evaluation batches call pmars, evalwar uses fc and date
:: inspect/run option calls pmarsv
:: Last modified Mar 6 98 
@echo off
:: set this to list command, if blank types...
set listprg=
:: where to save code...
set savedir=save
:: what os uses to start a task...
set startstr=start /m
:: (/m means minimized)
:: pmarsv command...
set pmarsv=pmarsv -b
:: default lines...
set lines=25
:: start with color mapping, on or off
set colsw=off
:: Colorize function assumes standard color text screen at
:: $B800, if it doesn't work set colsw=disable
::-------------------------
:: (sorry... I like ANSI)
set useansi=no
:swlines
mode con lines=%lines%
:main
cls
echo.
echo.
echo    System 4 Redcode Evolver
echo    ========================
echo.
echo.
echo    1 - Edit configuration file
echo    2 - Initialize a random start
if exist warriors\nul goto main1
echo    3 - Nothing to evolve
echo    4 - Nothing to look at
echo    5 - Nothing to evaluate
goto main2
:main1
if not exist sys4.pid echo    3 - Start evolution task
if exist sys4.pid     echo    3 - Halt evolution task
echo    4 - Look at warriors
if not exist warlist$ echo    5 - Evaluate warriors
if exist warlist$ if not exist evalflag echo    5 - Resume evaluating warriors
if exist warlist$ if exist evalflag echo    5 - Stop evaluating warriors
:main2
if not exist battle.out echo    6 - No battles to total
if exist battle.out echo    6 - Total up battles
if not exist scores.txt echo    7 - No scores to display
if exist scores.txt echo    7 - Display scores
echo    8 - Clear warriors array
echo    9 - Remove temp files
echo.
echo    R - Refresh menu options
echo    L - Screen lines = %lines%
echo    W - Make new random words
echo    Q - Quit
echo.
choice /c:123456789rlwq>nul
if errorlevel 13 goto quit
if errorlevel 12 goto makewords
if errorlevel 11 goto chlines
if errorlevel 10 goto main
if errorlevel 9 goto cleantemps
if errorlevel 8 goto cleanwarriors
if errorlevel 7 goto typescores
if errorlevel 6 goto scorelog
if errorlevel 5 goto evalwar
if errorlevel 4 goto look
if errorlevel 3 goto startstop
if errorlevel 2 goto init
if errorlevel 1 goto editconfig
echo No choice, I quit!
goto quit
:makewords
qbasic /run makeword.bas
goto main
:chlines
if %lines%==25 goto make43
set lines=25
goto swlines
:make43
set lines=43
goto swlines
:editconfig
edit config.pl
goto main
:init
if exist sys4.pid goto piderror
if exist evalflag goto evalerror
if not exist warriors\nul goto init1
echo Replace warriors with random... are you sure?
choice /c:ny>nul
if not errorlevel 2 goto main
deltree /y warriors
:init1
if exist sys4.vals del sys4.vals
perl makerand.pl
goto main
:startstop
if not exist warriors\nul goto main
if not exist sys4.pid goto startsys4
del sys4.pid
echo Wait for evolution task to stop
goto pnmain
:startsys4
if exist bakflag goto main
if exist evalflag goto evalerror
if exist warlist$ goto temperror
rem>sys4.pid
%startstr% sys4evol.bat
goto main
:scorelog
if not exist battle.out goto main
copy battle.out battle.txt>nul
call scorelog battle.txt scores.txt
del battle.txt
goto main
:look
if not exist warriors\nul goto main
if exist bakflag goto main
set mline=23
if %lines%==43 set mline=41
set script=map
set col=1
set row=2
:carunscr
cls
:harunscr
if .%useansi%==.yes echo [H
if not .%useansi%==.yes cls
if not .%useansi%==.yes echo.
perl %script%.pl
if %colsw%==on call colorize.bat %lines%
echo.
echo Names Scores siZes Gens gen10 Inspect Color eXit
choice /c:NSZG1ICX>nul
if errorlevel 8 goto main
if errorlevel 7 goto swcolor
if exist bakflag goto carunscr
if errorlevel 6 goto inspect1
if errorlevel 1 set script=map
if errorlevel 2 set script=mapscore
if errorlevel 3 set script=mapsize
if errorlevel 4 set script=mapgen1
if errorlevel 5 set script=mapgen
goto harunscr
:swcolor
if %colsw%==off set colsw=sw
if %colsw%==on set colsw=off
if %colsw%==sw set colsw=on
goto harunscr
:inspect1
if exist bakflag goto inspect1
cls
echo.
perl %script%.pl
if %colsw%==on call colorize.bat %lines%
echo.
echo List Test Quicktest Run Save Edit Kill or [Esc]
:inspect2
echo> setwar$.bas locate 1,22:? space$(40):c=%col%:r=%row%
echo>>setwar$.bas keyloop:a$=inkey$:x=0:if len(a$)=2 then x=asc(mid$(a$,2,1))
echo>>setwar$.bas if x=72 then r=r-1:if r=1 then r=2
echo>>setwar$.bas if x=80 then r=r+1:if r=%mline%+1 then r=%mline%
echo>>setwar$.bas if x=75 then c=c-2:if c=-1 then c=1
echo>>setwar$.bas if x=77 then c=c+2:if c=81 then c=79
echo>>setwar$.bas if not a$="" then if instr("tqrslke",a$) goto writebat 
echo>>setwar$.bas if not r=r1 or not c=c1 then locate 1,1,0:? "cursor at:";r-2;int((c-1)/2);"   ";
echo>>setwar$.bas r1=r:c1=c:locate r,c,1:goto keyloop
echo>>setwar$.bas writebat:d$=ltrim$(str$(r-2))
echo>>setwar$.bas f$=ltrim$(str$(int((c-1)/2))):w$=d$+"\"+f$
echo>>setwar$.bas c$=ltrim$(str$(c)):r$=ltrim$(str$(r))
echo>>setwar$.bas open "setwar$.bat" for output as #1
echo>>setwar$.bas ? #1,"set warrior=";w$:? #1,"set row=";r$
echo>>setwar$.bas ? #1,"set col=";c$:? #1,"set func=";a$
echo>>setwar$.bas locate 1,22:close #1:system
qbasic /run setwar$.bas
del setwar$.bas
call setwar$.bat
del setwar$.bat
if %func%==l goto listred
if %func%==t goto testwarrior
if %func%==q goto testwarrior
if %func%==s goto savewarrior
if %func%==e goto editwarrior
if %func%==k goto killwarrior
if %func%==r goto runwarrior
goto carunscr
:testwarrior
if not exist warriors\%warrior%.red goto inspect1
cls
echo.
if %func%==t call test1war.bat warriors\%warrior%.red 100
if %func%==q call test1war.bat warriors\%warrior%.red 10
echo.
pause
goto inspect1
:runwarrior
if not exist warriors\%warrior%.red goto inspect1
cls
>nul %pmarsv% warriors\%warrior%.red
goto inspect1
:savewarrior
if not exist warriors\%warrior%.red goto inspect1
echo Saving...
if not exist %savedir%\nul md %savedir%
echo>name.bat @echo off
echo>>name.bat set name=%%1%%2-%%3
find ";name"<warriors\%warrior%.red>getname$.bat
call getname$.bat
del getname$.bat
del name.bat
copy warriors\%warrior%.red %savedir%\%name%.red>nul
copy warriors\%warrior%.score %savedir%\%name%.score>nul
goto inspect2
:editwarrior
if not exist warriors\%warrior%.red goto inspect1
if exist sys4.pid goto inspect2
if exist evalflag goto inspect2
edit warriors\%warrior%.red
edit warriors\%warrior%.score
goto inspect1
:killwarrior
if not exist warriors\%warrior%.red goto inspect1
if exist sys4.pid goto inspect2
if exist evalflag goto inspect2
echo Kill warrior %warrior% ???
choice /c:ny>nul
if not errorlevel 2 goto inspect2
del warriors\%warrior%.red
del warriors\%warrior%.score
goto inspect1
:listred
if not exist warriors\%warrior%.red goto inspect1
if .%listprg%==. goto typewar
call %listprg% warriors\%warrior%.red
goto inspect1
:typewar
cls
type warriors\%warrior%.red|more
pause
goto inspect1
:typescores
if .%listprg%==. goto typedos
call %listprg% scores.txt
goto main
:typedos
if not exist scores.txt goto main
type scores.txt|more
pause
goto main
:evalwar
if not exist warriors\nul goto main
if exist evalflag goto stopeval
if exist sys4.pid goto piderror
if exist warlist$ goto evalcontinue
cls
echo.
if not exist warlist$ echo Start evaluation task...
if exist warlist$ echo Continue evaluation task...
echo.
echo Select:  1) warriors\ at 10 rounds
echo          2) warriors\ at 30 rounds
echo          3) save\ at 30 rounds
echo          4) save\ at 100 rounds
echo          X) exit
choice /c:1234x>nul
if errorlevel 5 goto main
if errorlevel 1 set rnds=10
if errorlevel 1 set warriors=warriors\*.red
if errorlevel 2 set rnds=30
if errorlevel 2 set warriors=warriors\*.red
if errorlevel 3 set rnds=30
if errorlevel 3 set warriors=%savedir%\*.red
if errorlevel 4 set rnds=100
if errorlevel 4 set warriors=%savedir%\*.red
%startstr% evalwar.bat %rnds% %warriors%
goto main
:evalcontinue
%startstr% evalwar.bat
goto main
:stopeval
del evalflag
echo Wait for evaluation task to stop
goto pnmain
:cleanwarriors
if exist sys4.pid goto piderror
if exist evalflag goto evalerror
echo Remove warriors, scores and reset? Are you sure?
choice /c:ny>nul
if not errorlevel 2 goto main
if exist warriors\nul deltree /y warriors
if exist sys4.vals del sys4.vals
if exist scores.txt del scores.txt
if exist battle.out del battle.out
goto main
:cleantemps
if exist sys4.pid goto piderror
if exist evalflag goto evalerror
echo Remove temp files? Are you sure?
choice /c:ny>nul
if not errorlevel 2 goto main
if exist scores$$$ del scores$$$
if exist test$.war del test$.war
if exist warlist$ del warlist$
if exist envsave$.bat del envsave$.bat
if exist wartemp$.bat del wartemp$.bat
if exist enter.bat del enter.bat
if exist evalflag del evalflag
if exist bakflag del bakflag
if exist tempred.1 del tempred.1
if exist tempred.2 del tempred.2
if exist mapcr$ del mapcr$
goto main
:pnmain
pause
goto main
:temperror
echo Remove temp files first
goto pnmain
:piderror
echo Halt evolution task first
goto pnmain
:evalerror
echo Halt evaluation task first
goto pnmain
:quit
