#!/usr/bin/perl

# A configuration file

# the pmars command
$PMARS=`which pmars`;
chomp($PMARS);

# where to get names for the warriors
$DICT="/usr/lib/games/hangman-words";

# size of field (a square, e.g. 100 is 100x100 square)
$SIZE=80;

# how many fights per battle
$FIGHTS=100;

# warrior data
$WARSIZE=20;
$WARCORESIZE=800;
$WARLOCALCHANCE=75; # in %
$MUTATIONCHANCE=3; # in % (an instruction changes) 
$SIZECHANGECHANCE=3; # in % (instruction deleted/added)

$MINSCORE=80; #minimum score to survive (initial value)
$MAXSCORE=145; #anything above this will allways survive
$FIGHTGRACE=1; #fights before minscore is used

$SCORERATE=1; #rate (% of the difference between minscore and maxscore)
$SCORETIMES=1000; #after how many fights adjust score


$SCORELAST=10; #count score as the average of last x fights

# backup warriors to disk every x runs
$BACKUPFREQ=3000;

# default env
$DEFENV='-@ 94t.opt';

# the opcodes used
@opcodes=('DAT','MOV','ADD','SUB','MUL','DIV','MOD','JMP','JMZ','JMN','DJN','CMP','SLT','SPL','LDP','STP');
@modifiers=('A','B','AB','BA','F','X','I');
@modes=('#','$','@','*','<','>','{','}');

