#!/usr/bin/perl

# A configuration file

# the pmars command
$PMARS="pmars";
# chomp($PMARS);

# where to get names for the warriors
$DICT="words.txt";

# size of field (a square, e.g. 100 is 100x100 square)
$SIZE=20;

# how many fights per battle
$FIGHTS=15;

# warrior data
$WARSIZE=25;
$WARCORESIZE=8000;
$WARLOCALCHANCE=50; # in %
$MUTATIONCHANCE=3; # in % (an instruction changes) 
$SIZECHANGECHANCE=3; # in % (instruction deleted/added)

$MINSCORE=85; #minimum score to survive (initial value)
$MAXSCORE=160; #anything above this will allways survive
$FIGHTGRACE=1; #fights before minscore is used

$SCORERATE=1; #rate (% of the difference between minscore and maxscore)
$SCORETIMES=500; #after how many fights adjust score


$SCORELAST=10; #count score as the average of last x fights

# backup warriors to disk every x runs
$BACKUPFREQ=500;

# restart program every x backups
$RESTARTFREQ=5;

# default env
$DEFENV='-@ 94t.opt';

# the opcodes used
@opcodes=('DAT','MOV','ADD','SUB','MUL','DIV','MOD','JMP','JMZ','JMN','DJN','CMP','SLT','SPL','LDP','STP');
@modifiers=('A','B','AB','BA','F','X','I');
@modes=('#','$','@','*','<','>','{','}');

