#!/usr/bin/perl

do "./config.pl" || die "No config.pl file!\n";

sub MakeRandOpcode
{
	$warsize=$_[0];
	$lines=$_[1];
	$opcode=$opcodes[int(rand($#opcodes))];
	$modifier=$modifiers[int(rand($#modifiers))];
	$mode1=$modes[int(rand($#modes))];
	$mode2=$modes[int(rand($#modes))];
	if (int(rand(100)) >= $WARLOCALCHANCE) {
		$address1=int(rand($warsize));
		$address1="L$address1";
	} else {
		$address1=int(rand($WARCORESIZE));
	}
	if (int(rand(100)) >= $WARLOCALCHANCE) {
		$address2=int(rand($warsize));
		$address2="L$address2";
	} else {
		$address2=int(rand($WARCORESIZE));
	}

	$line="L$lines\t$opcode.$modifier\t$mode1 $address1,\t$mode2 $address2";

	return $line;
}

$|=1;

srand(time|$$);

print "Reading dictionary ...";
open(FILE,$DICT);
chop(@words=<FILE>);
close(FILE);
print " done.\n";

print "Making dirs ...";
mkdir("warriors",0755) if (!(-r "warriors"));
for ($i=0; $i<$SIZE; $i++) {
	next if (-r "warriors/$i");
	mkdir("warriors/$i",0755);
}
print " done.\n";

print "Creating warriors ...\n";
for ($x=0; $x<$SIZE; $x++) {
	printf("%d\r",$x);
	for ($y=0; $y<$SIZE; $y++) {
		do {
			$name=ucfirst "$words[int(rand($#words))]";
		} while ($name=~/^[^A-Za-z0-9]+$/ || $name_cache{$name});

		open(FILE,">warriors/$x/$y.red");
		print FILE ";System 4 warrior\n";
		print FILE ";name $name ($x,$y)\n";
		print FILE ";assert 1\n\n";
		$size=int(rand($WARSIZE)+1);
		for ($lines=0; $lines<$size; $lines++) {
			$line=MakeRandOpcode($size,$lines);
			print FILE "$line\n";
		}
		for(;$lines<$WARSIZE;$lines++) {
			print FILE "L$lines\tDAT.F\t\$ 0,\t\$ 0\t;buffer\n";
		}
		close(FILE);

		open(FILE,">warriors/$x/$y.score");
		print FILE "Size $size\n";
		print FILE "Score 0\n";
		print FILE "Fights 0\n";
		print FILE "Kids 0\n";
		print FILE "Generation 0\n";
		close(FILE);

		$name_cache{$name}=1;
	}
}

print "All done.\n";
